require('player')
require('coin1')
require('coin2')
require('coin3')
require('gamera')
function love.load()

	-- Camera Setup
	cam = gamera.new(0,0,2000,2000)
	cam:setWindow(0,0,800,600)
	
	console_input = ''
	-- +INFO
	
	app_version = '0.1 * Unreleased Pre-Alpha'
	app_name = 'Adventure'
	error_sec = 'error_finding_value'
	state, percent, seconds = love.system.getPowerInfo( )
	os_string = love.system.getOS( )
	cores = love.system.getProcessorCount( )
	time_sleep = 4
	time_sleep2 = 2
	check_update = 'Checking for update...'
	allow_update = False
	update_true = 'A new update has been installed!'
	update_false = 'No new update available!'
	print(check_update)
	love.timer.sleep(time_sleep)
	if allow_update == 'True' then
		print(update_true)
	else
		print(update_false)
		
	end
	
	print()
	print("## " ..app_name.. " - Version " ..app_version.. " ##")
	print()
	print("+-+-+ SYSTEM +-+-+")
	print("OS: " ..os_string)
	if state == "battery" then
		print("POWER: USING BATTERY")
		print("POWER%: " ..percent)
		print("TIME REMAINING: " ..error_sec)
	else
		print("POWER: NO BATTERY")
	end
	print("CORES: " ..cores)
	print()
	print('+-+-+ HELP +-+-+')
	print('Controls:')
	print('wasd = Movement')
	print('m and , = Mute/Unmute')
	print('f and escape = Fullscreen/Windowed')
	print()
	print()
	print('+-+-+ GAME LOG +-+-+')
	-- -INFO
	
	
	amount_money = {}
	r = 37
	b = 141
	g = 17
	p = Player:new()
	coin_ent1 = Coin1:new()
	coin_ent2 = Coin2:new()
	coin_ent3 = Coin3:new()
	
	main = love.graphics.newFont("resource/font/font.ttf", 14)
	love.graphics.setBackgroundColor( r, b, g )
	
	bgm_music = love.audio.newSource("resource/sfx/bgm.mp3", "stream")
	pickup_sfx = love.audio.newSource("resource/sfx/coin1.ogg", "static")
	
	bgm_music:setLooping(true)
	bgm_music:setVolume(.02)
	pickup_sfx:setVolume(.02)
	
	-- Ground
	grass = love.graphics.newImage("resource/img/ground.bmp")
	
		
	if not love.filesystem.exists("money.lua") then
		coins = love.filesystem.newFile("money.lua")
	end
	
	--love.filesystem.write("money.lua", "p.money\n=\n" ..p.money)

	for lines in love.filesystem.lines("money.lua") do
		table.insert(amount_money, lines)
	end
	
	p.money = amount_money[3]
	
	bgm_music:play()
end

function love.draw()

	love.graphics.setFont(main)
	love.graphics.print('Health:' ..p.health, 10, 10)
	love.graphics.print('Money:' ..p.money, o2.sx, o2.sy)
	love.graphics.print('|', 128, 10)
	love.graphics.print('FPS:' ..tostring(love.timer.getFPS( )), 700, 10)

	cam:draw(function(l,t,w,h)
		love.graphics.draw( grass, 0,   0, 0, 1, 1, 0 )
		coin_ent1:draw()
		coin_ent2:draw()
		coin_ent3:draw()

		if o.facing == 'left' then
			love.graphics.draw( o.mpl, o.x, o.y, 0, 1, 1, 0 )
		end
		if o.facing == 'right' then
			love.graphics.draw( o.mpr, o.x, o.y, 0, 1, 1, 0 )
		end
		if o.facing == 'front' then
			love.graphics.draw( o.mpf, o.x, o.y, 0, 1, 1, 0 )
		end
		if o.facing == 'back' then
			love.graphics.draw( o.mpb, o.x, o.y, 0, 1, 1, 0 )
		end
	end)
	
	love.graphics.setFont(main)
	love.graphics.print('Health:' ..p.health, 10, 10)
	love.graphics.print('Money:' ..p.money, o2.sx, o2.sy)
	love.graphics.print('|', 128, 10)
	love.graphics.print('FPS:' ..tostring(love.timer.getFPS( )), 700, 10)
end

function love.update(dt)
	p:update(dt)
	coin_ent1:update(dt)
	coin_ent2:update(dt)
	coin_ent3:update(dt)
	cam:setPosition(o.x, o.y)
	
	if love.keyboard.isDown('f') then
		success = love.window.setFullscreen(true)
	end
	
	if love.keyboard.isDown('escape') then
		success = love.window.setFullscreen(false)
	end
	
	if love.keyboard.isDown('m') then
		bgm_music:setVolume(0)
		pickup_sfx:setVolume(0)
	end
	
	if love.keyboard.isDown(',') then
		bgm_music:setVolume(.02)
		pickup_sfx:setVolume(.02)
	end
		
	if love.keyboard.isDown('q') then
		love.event.quit()
	end
	
	--if p.money == tonumber(p.money) then
	--	love.filesystem.write("money.lua", "p.amount_money\n=\n" ..p.money)
	--end
end
function love.focus(bool)
	if bool then
		print("RESUMED")
	else
		print("PAUSED")
	end
end

function love.quit()
	print("Saving to log...")
	love.event.quit()
end